//
// object.h
//
// The Object class
//

#ifndef __OBJECT_H__
#define __OBJECT_H__

#pragma warning(disable:4786)

#include "dl.h"

#include "modeler.h"

#define MAX_OBJECTS		1024

class CGLView;
class ctrlPanel;
class Scene;

class Object {
public:
	Object(char* dllname, void *args=0);
	~Object();

	void setInit(lpInitFunc init_proc);
	void setRedraw(lpRedrawFunc redraw_proc);

	lpInitFunc init;
	lpRedrawFunc redraw;
	lpPatchControlFunc patchControl;
	lpGetNameFunc getName;

	bool isLoaded();

	float getControlValue(int id);
	void *getPtr(int id);

	void setScene(Scene *scn) { m_pScene=scn; };
	Scene *getScene() { return m_pScene; };

	void refresh();

	void toggleVisibility() 
		{ m_bVisible=!m_bVisible; };
	bool isVisible() 
		{ return m_bVisible; };

	char *getObjName() { return objname; };
	int  getObjID() { return id; };

	char *getCurveName(int id);
	void toggleCurve(int id);
	void setControlValue(int id, float v);
	void setCurveValue(int id, float v);

	ctrlPanel *m_pPanel;

private:
	DLHANDLE m_DLHandle;

	Scene *m_pScene;
		
	bool m_bLoaded;

	static bool null_init(void *v);
	static void null_redraw(int id,int drawMode);

	char objname[64];
	int id;

	bool m_bVisible;
};

#endif